Subject: BUG: unable to handle kernel NULL pointer dereference in cfg80211_wext_siwfrag

From: syzbot <[email-masked]>
Date: Mon, 06 Jan 2020 22:04:08 -0800

Hello,

syzbot found the following crash on:

HEAD commit:    d89091a4 macb: Don't unregister clks unconditionally
git tree:       net
console output: https://syzkaller.appspot.com/x/log.txt?x=130a0915e00000
kernel config:  https://syzkaller.appspot.com/x/.config?x=f2f3ef188b7e16cf
dashboard link: https://syzkaller.appspot.com/bug?extid=e8a797964a4180eb57d5
compiler:       gcc (GCC) 9.0.0 20181231 (experimental)
syz repro:      https://syzkaller.appspot.com/x/repro.syz?x=15c85915e00000
C reproducer:   https://syzkaller.appspot.com/x/repro.c?x=11c02bc1e00000

IMPORTANT: if you fix the bug, please add the following tag to the commit:
Reported-by: [email-masked]

device veth1_vlan entered promiscuous mode
BUG: kernel NULL pointer dereference, address: 0000000000000000
#PF: supervisor instruction fetch in kernel mode
#PF: error_code(0x0010) - not-present page
PGD a066f067 P4D a066f067 PUD 958e3067 PMD 0
Oops: 0010 [#1] PREEMPT SMP KASAN
CPU: 0 PID: 9308 Comm: syz-executor762 Not tainted 5.5.0-rc4-syzkaller #0
Hardware name: Google Google Compute Engine/Google Compute Engine, BIOS  
Google 01/01/2011
RIP: 0010:0x0
Code: Bad RIP value.
RSP: 0018:ffffc90001d37a78 EFLAGS: 00010246
RAX: dffffc0000000000 RBX: ffff8882186a6540 RCX: ffffffff876a3fd1
RDX: 1ffffffff1148afc RSI: 0000000000000004 RDI: ffff8882186a6540
RBP: ffffc90001d37ab8 R08: ffff88809f9ba580 R09: ffffed1015d0703d
R10: ffffed1015d0703c R11: ffff8880ae8381e3 R12: ffffffff88a45660
R13: ffff8880a7aed000 R14: ffffc90001d37bb0 R15: 0000000000000000
FS:  0000000001a01880(0000) GS:ffff8880ae800000(0000) knlGS:0000000000000000
CS:  0010 DS: 0000 ES: 0000 CR0: 0000000080050033
CR2: ffffffffffffffd6 CR3: 00000000a5220000 CR4: 00000000001406f0
DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000
DR3: 0000000000000000 DR6: 00000000fffe0ff0 DR7: 0000000000000400
Call Trace:
  rdev_set_wiphy_params net/wireless/rdev-ops.h:542 [inline]
  cfg80211_wext_siwfrag+0x279/0x910 net/wireless/wext-compat.c:307
  ioctl_standard_call+0xca/0x1d0 net/wireless/wext-core.c:1015
  wireless_process_ioctl.constprop.0+0x236/0x2b0 net/wireless/wext-core.c:953
  wext_ioctl_dispatch net/wireless/wext-core.c:986 [inline]
  wext_ioctl_dispatch net/wireless/wext-core.c:974 [inline]
  wext_handle_ioctl+0x106/0x1c0 net/wireless/wext-core.c:1047
  sock_ioctl+0x47d/0x790 net/socket.c:1112
  vfs_ioctl fs/ioctl.c:47 [inline]
  file_ioctl fs/ioctl.c:545 [inline]
  do_vfs_ioctl+0x977/0x14e0 fs/ioctl.c:732
  ksys_ioctl+0xab/0xd0 fs/ioctl.c:749
  __do_sys_ioctl fs/ioctl.c:756 [inline]
  __se_sys_ioctl fs/ioctl.c:754 [inline]
  __x64_sys_ioctl+0x73/0xb0 fs/ioctl.c:754
  do_syscall_64+0xfa/0x790 arch/x86/entry/common.c:294
  entry_SYSCALL_64_after_hwframe+0x49/0xbe
RIP: 0033:0x4423f9
Code: 18 89 d0 c3 66 2e 0f 1f 84 00 00 00 00 00 0f 1f 00 48 89 f8 48 89 f7  
48 89 d6 48 89 ca 4d 89 c2 4d 89 c8 4c 8b 4c 24 08 0f 05 <48> 3d 01 f0 ff  
ff 0f 83 5b 10 fc ff c3 66 2e 0f 1f 84 00 00 00 00
RSP: 002b:00007ffd5699e578 EFLAGS: 00000246 ORIG_RAX: 0000000000000010
RAX: ffffffffffffffda RBX: 0000000000000003 RCX: 00000000004423f9
RDX: 0000000020000040 RSI: 0800000000008b24 RDI: 0000000000000003
RBP: 0000000000000004 R08: 0000000000000025 R09: 0000000000000025
R10: 0000000000000025 R11: 0000000000000246 R12: 0000000000000000
R13: 0000000000403970 R14: 0000000000000000 R15: 0000000000000000
Modules linked in:
CR2: 0000000000000000
---[ end trace d5d5f75393c2f62d ]---
RIP: 0010:0x0
Code: Bad RIP value.
RSP: 0018:ffffc90001d37a78 EFLAGS: 00010246
RAX: dffffc0000000000 RBX: ffff8882186a6540 RCX: ffffffff876a3fd1
RDX: 1ffffffff1148afc RSI: 0000000000000004 RDI: ffff8882186a6540
RBP: ffffc90001d37ab8 R08: ffff88809f9ba580 R09: ffffed1015d0703d
R10: ffffed1015d0703c R11: ffff8880ae8381e3 R12: ffffffff88a45660
R13: ffff8880a7aed000 R14: ffffc90001d37bb0 R15: 0000000000000000
FS:  0000000001a01880(0000) GS:ffff8880ae800000(0000) knlGS:0000000000000000
CS:  0010 DS: 0000 ES: 0000 CR0: 0000000080050033
CR2: ffffffffffffffd6 CR3: 00000000a5220000 CR4: 00000000001406f0
DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000
DR3: 0000000000000000 DR6: 00000000fffe0ff0 DR7: 0000000000000400

---
This bug is generated by a bot. It may contain errors.
See https://goo.gl/tpsmEJ for more information about syzbot.
syzbot engineers can be reached at [email-masked].

syzbot will keep track of this bug report. See:
https://goo.gl/tpsmEJ#status for how to communicate with syzbot.
syzbot can test patches for this bug, for details see:
https://goo.gl/tpsmEJ#testing-patches